<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: &lt;SDProgressiveImageCoder&gt; Protocol Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Instance Methods</a> &#124;
<a href="protocol_s_d_progressive_image_coder-p-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">&lt;SDProgressiveImageCoder&gt; Protocol Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#import &lt;<a class="el" href="_s_d_image_coder_8h_source.html">SDImageCoder.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for &lt;SDProgressiveImageCoder&gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="protocol_s_d_progressive_image_coder-p.png" usemap="#_3CSDProgressiveImageCoder_3E_map" alt=""/>
  <map id="_3CSDProgressiveImageCoder_3E_map" name="_3CSDProgressiveImageCoder_3E_map">
<area href="protocol_s_d_image_coder-p.html" alt="&lt;SDImageCoder&gt;" shape="rect" coords="189,56,368,80"/>
<area href="interface_s_d_image_a_p_n_g_coder.html" alt="SDImageAPNGCoder" shape="rect" coords="0,168,179,192"/>
<area href="interface_s_d_image_g_i_f_coder.html" alt="SDImageGIFCoder" shape="rect" coords="189,168,368,192"/>
<area href="interface_s_d_image_i_o_coder.html" alt="SDImageIOCoder" shape="rect" coords="378,168,557,192"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Instance Methods</h2></td></tr>
<tr class="memitem:aaaba39bca164cbbb3abeffe714eff82b"><td class="memItemLeft" align="right" valign="top">(BOOL)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_progressive_image_coder-p.html#aaaba39bca164cbbb3abeffe714eff82b">canIncrementalDecodeFromData:</a></td></tr>
<tr class="separator:aaaba39bca164cbbb3abeffe714eff82b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:a20a4f0d47c665890260011ccdc4ac3f9"><td class="memItemLeft" align="right" valign="top">(nonnull instancetype)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_progressive_image_coder-p.html#a20a4f0d47c665890260011ccdc4ac3f9">initIncrementalWithOptions:</a></td></tr>
<tr class="separator:a20a4f0d47c665890260011ccdc4ac3f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29623920fcd12831ac6237687d99a48b"><td class="memItemLeft" align="right" valign="top">(void)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_progressive_image_coder-p.html#a29623920fcd12831ac6237687d99a48b">updateIncrementalData:finished:</a></td></tr>
<tr class="separator:a29623920fcd12831ac6237687d99a48b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f60adafefc289463a47187d0b0f9b82"><td class="memItemLeft" align="right" valign="top">(nullable UIImage *)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_progressive_image_coder-p.html#a9f60adafefc289463a47187d0b0f9b82">incrementalDecodedImageWithOptions:</a></td></tr>
<tr class="separator:a9f60adafefc289463a47187d0b0f9b82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_protocol_s_d_image_coder-p"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_protocol_s_d_image_coder-p')"><img src="closed.png" alt="-"/>&#160;Instance Methods inherited from <a class="el" href="protocol_s_d_image_coder-p.html">&lt;SDImageCoder&gt;</a></td></tr>
<tr class="memitem:af2bb27da57d38812b813d9edb2703f83 inherit pub_methods_protocol_s_d_image_coder-p"><td class="memItemLeft" align="right" valign="top">(BOOL)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_coder-p.html#af2bb27da57d38812b813d9edb2703f83">canDecodeFromData:</a></td></tr>
<tr class="separator:af2bb27da57d38812b813d9edb2703f83 inherit pub_methods_protocol_s_d_image_coder-p"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49af4eef0001ffbd1ed0dde2fc4a005a inherit pub_methods_protocol_s_d_image_coder-p"><td class="memItemLeft" align="right" valign="top">(nullable UIImage *)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_coder-p.html#a49af4eef0001ffbd1ed0dde2fc4a005a">decodedImageWithData:options:</a></td></tr>
<tr class="separator:a49af4eef0001ffbd1ed0dde2fc4a005a inherit pub_methods_protocol_s_d_image_coder-p"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6de5e276818707c97d89f018e7200be inherit pub_methods_protocol_s_d_image_coder-p"><td class="memItemLeft" align="right" valign="top">(BOOL)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_coder-p.html#ad6de5e276818707c97d89f018e7200be">canEncodeToFormat:</a></td></tr>
<tr class="separator:ad6de5e276818707c97d89f018e7200be inherit pub_methods_protocol_s_d_image_coder-p"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cef5bb5e73e02fe9fc2a59dcccc55dc inherit pub_methods_protocol_s_d_image_coder-p"><td class="memItemLeft" align="right" valign="top">(nullable NSData *)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_coder-p.html#a8cef5bb5e73e02fe9fc2a59dcccc55dc">encodedDataWithImage:format:options:</a></td></tr>
<tr class="separator:a8cef5bb5e73e02fe9fc2a59dcccc55dc inherit pub_methods_protocol_s_d_image_coder-p"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This is the image coder protocol to provide custom progressive image decoding. These methods are all required to implement. </p><dl class="section note"><dt>Note</dt><dd>Pay attention that these methods are not called from main queue. </dd></dl>
</div><h2 class="groupheader">Method Documentation</h2>
<a id="aaaba39bca164cbbb3abeffe714eff82b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaaba39bca164cbbb3abeffe714eff82b">&#9670;&nbsp;</a></span>canIncrementalDecodeFromData:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (BOOL) canIncrementalDecodeFromData: </td>
          <td></td>
          <td class="paramtype">(nullable NSData *)&#160;</td>
          <td class="paramname"><em>data</em></td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Returns YES if this coder can incremental decode some data. Otherwise, it should be passed to another coder.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>The image data so we can look at it </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>YES if this coder can decode the data, NO otherwise </dd></dl>

</div>
</div>
<a id="a9f60adafefc289463a47187d0b0f9b82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9f60adafefc289463a47187d0b0f9b82">&#9670;&nbsp;</a></span>incrementalDecodedImageWithOptions:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (nullable UIImage *) incrementalDecodedImageWithOptions: </td>
          <td></td>
          <td class="paramtype">(nullable SDImageCoderOptions *)&#160;</td>
          <td class="paramname"><em>options</em></td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Incremental decode the current image data to image. </p><dl class="section note"><dt>Note</dt><dd>Due to the performance issue for progressive decoding and the integration for image view. This method may only return the first frame image even if the image data is animated image. If you want progressive animated image decoding, conform to <code><a class="el" href="protocol_s_d_animated_image_coder-p.html">SDAnimatedImageCoder</a></code> protocol as well and use <code>animatedImageFrameAtIndex:</code> instead.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">options</td><td>A dictionary containing any progressive decoding options. PassSDImageCoderDecodeScaleFactor: @(1.0)} to specify scale factor for progressive image </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The decoded image from current data </dd></dl>

</div>
</div>
<a id="a20a4f0d47c665890260011ccdc4ac3f9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a20a4f0d47c665890260011ccdc4ac3f9">&#9670;&nbsp;</a></span>initIncrementalWithOptions:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (nonnull instancetype) initIncrementalWithOptions: </td>
          <td></td>
          <td class="paramtype">(nullable SDImageCoderOptions *)&#160;</td>
          <td class="paramname"><em>options</em></td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Because incremental decoding need to keep the decoded context, we will alloc a new instance with the same class for each download operation to avoid conflicts This init method should not return nil</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">options</td><td>A dictionary containing any progressive decoding options (instance-level). PassSDImageCoderDecodeScaleFactor: @(1.0)} to specify scale factor for progressive animated image (each frames should use the same scale). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A new instance to do incremental decoding for the specify image format </dd></dl>

</div>
</div>
<a id="a29623920fcd12831ac6237687d99a48b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a29623920fcd12831ac6237687d99a48b">&#9670;&nbsp;</a></span>updateIncrementalData:finished:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (void) updateIncrementalData: </td>
          <td></td>
          <td class="paramtype">(nullable NSData *)&#160;</td>
          <td class="paramname"><em>data</em></td>
        </tr>
        <tr>
          <td class="paramkey">finished:</td>
          <td></td>
          <td class="paramtype">(BOOL)&#160;</td>
          <td class="paramname"><em>finished</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Update the incremental decoding when new image data available</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>The image data has been downloaded so far </td></tr>
    <tr><td class="paramname">finished</td><td>Whether the download has finished </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this protocol was generated from the following file:<ul>
<li><a class="el" href="_s_d_image_coder_8h_source.html">SDImageCoder.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
